/// class PD.Manage.Modules.SyncUserCommand

PD.Manage.Modules.SyncUserCommand =
PD.Commands.Command.extend({

    //===================================
    // PUBLIC METHODS
    //===================================

    setDefaults: function () {
        this.props("id", "sync/user");
        this.props("enabled", true);
        this.props("icon", PD.Path.to16x16("arrow_circle2.png"));
        this.props("label", "Sync User");
        this.props("tooltip", "Update the selected User with data<br/>retrieved from Active Directory.");
        this.state("users", null);
    },

    setState: function (state) {
        this._super(state);
        this.props("enabled", this._isEnabled());
    },

    execute: function (e) {
        this._super(e);

        var user = _.first(this.state("users"));

        this._showSyncDialog(user.id);

    },

    //===================================
    // PRIVATE METHODS
    //===================================

    _isEnabled: function () {
        return _.isArray(this.state("users"))
            && this.state("users").length == 1;;
    },

    _showSyncDialog: function (id) {

        PDJS.Shared.TaskStatusDialog.open({
            title: "Sync | User",
            taskStart: (e) => {

                PD.ajax({
                    type: "POST",
                    url: PD.Path.resolve(`~/Manage/ActiveDirectory/SyncUser/${id}`),
                    success: (e2) => {
                        e.startPolling(e2);
                    },
                    error: (e2) => {
                        e.abort(e2.responseJSON);
                        e2.errorHandled = true;
                    }
                });

            },
            taskSuccess: (e) => {

                PD.context
                    .get_default()
                    .get_events()
                    .publish("sync/refresh");

            }
        });

    }

});